#include <iostream>
#include "WebInterface.h"
#include <Wt/WServer>
#include <Wt/WConfig.h>
#include "GroovePlayer.h"
#include <experimental/filesystem> //TODO:Change to non-gcc way when officially using c++17

Wt::WApplication* createApplication(const Wt::WEnvironment& env)
{
    return new WebInterface(env);
}

int main ( int argc, char** argv )
{
    try {
        Wt::WServer server(argv[0]);
        server.logger().setFile(std::filesystem::current_path()/"arb-log.txt");
        server.setServerConfiguration(argc, argv, WTHTTP_CONFIGURATION);
        server.addEntryPoint(Wt::Application, createApplication);
        if(server.start())
        {
            GroovePlayerMgr::getInstance();
            int sig = Wt::WServer::waitForShutdown(argv[0]);
            GroovePlayerMgr::getInstance()->shutdown();
            server.stop();
        }
        return 0;
    }
    catch (Wt::WServer::Exception& e)
    {
        std::cerr << e.what() << "\n";
        return 1;
    }
}
